/*->h.str */


typedef struct boxstr
{
 int x;
 int y;
 int w;
 int h;
} boxstr;



typedef struct aboxstr
{
 int x0;
 int y0;
 int x1;
 int y1;
} aboxstr;



typedef struct zoomstr
{
 int mul;
 int div;
} zoomstr;


typedef struct spanstr
{
 int xlo;
 int xhi;


} spanstr;



typedef struct
{
 int flags;
 int pause;
 int xmul;
 int xdiv;
 int ymul;
 int ydiv;
 int cx;
 int cy;
 int copies;

 int box0;             /* box to put image in, os units  */
 int box1;             /* 0,1 bottom left hand corner    */
 int box2;             /* 2,3 top right hand corner      */
 int box3;

 int height;           /* real height in 72000'ths */
 int width;            /* real width in 72000'ths  */
} pset;




typedef struct docdatastr
{
 int width;
 int height;
 int xres;
 int yres;




} docdatastr;



#define CL_RGB   0
#define CL_CMYK  1
#define CL_GREY  2
#define CL_ALPHA 3


typedef struct ipalstr
{
 int word[256];
 int ncolours;
 int palclass;

} ipalstr;




typedef struct imagestr
{
 int               x;
 int               y;
 int               z;

 int               bpp;
 int               xpix;
 int               ypix;
 int               xdpi;
 int               ydpi;
 ipalstr           ipal;

 int               wwidth;  /* width in words */
 int               size;
 int               data[1];

} imagestr;



#define IM 0
#define AL 1


typedef struct ximagestr
{
 struct ximagestr * xnext;
 struct ximagestr * xprev;

 struct ximagestr * redo;
 struct ximagestr * undo;

 imagestr         * sim[2];

} ximagestr;




typedef struct infostr
{
 char * text;
 int    n;
 int    handle;
} infostr;



#define FRAMENAMELEN 32


typedef struct framestr
{
 int            offset;             /* offset in file of this image */
 char           name[FRAMENAMELEN];

 ximagestr    * xim;                /* stores raster form of frame */

 infostr        info;

 int            fbpp;               /* used for original values in file */
 int            fxpix;              /* these values are not changed     */
 int            fypix;
 int            fxdpi;
 int            fydpi;

} framestr;





#define FILENAMELEN 256


typedef struct filestr
{
 char             sname[FILENAMELEN];
 char             oname[FILENAMELEN];

 int              modded;             /* file modified ?       */

 struct filestr * next;               /* next file in chain    */
 struct filestr * prev;               /* prev file in chain    */


 int              framen;
 framestr       * frames;             /* array of frames       */
 void           * data;               /* array of private data for file type */
 pset             ps;
 int              width;
 int              height;
 int              type;

} filestr;





